import { _ as _applyDecoratedDescriptor, a as _initializerDefineProperty, b as _defineProperty } from '../_rollupPluginBabelHelpers-997cc32f.js';
import Component from '@glimmer/component';
import { inject } from '@ember/service';
import { next } from '@ember/runloop';
import { use, resource } from 'ember-resources';
import { setOwner } from '@ember/application';
import { precompileTemplate } from '@ember/template-compilation';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("{{#if this.renderInPlace}}\n  {{yield}}\n{{else if this.target}}\n  {{#if this.target.multiple}}\n    {{#in-element this.target.element insertBefore=null}}\n      {{yield}}\n    {{/in-element}}\n  {{else}}\n    {{#in-element this.target.element}}\n      {{yield}}\n    {{/in-element}}\n  {{/if}}\n{{/if}}\n");

var _dec, _class, _descriptor, _class2, _descriptor2;
let Tracker = (_dec = inject('-portal'), (_class = class Tracker {
  constructor() {
    _initializerDefineProperty(this, "portalService", _descriptor, this);
    _defineProperty(this, "_target", void 0);
  }
  modify(newTarget) {
    const previousTarget = this._target;
    next(() => {
      this.portalService.registerPortal(newTarget);
      if (previousTarget) {
        this.portalService.unregisterPortal(previousTarget);
      }
    });
    this._target = newTarget;
  }
  get target() {
    return this._target ? this.portalService.getTarget(this._target) : undefined;
  }
  destroy() {
    if (!this._target) {
      return;
    }
    this.portalService.unregisterPortal(this._target);
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "portalService", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class));
function PortalTrackerResource(inputFn) {
  const state = new Tracker();
  return resource(({
    on,
    owner
  }) => {
    setOwner(state, owner);
    on.cleanup(() => state.destroy());
    return () => {
      state.modify(inputFn());
      return state;
    };
  });
}
let Portal = (_class2 = class Portal extends Component {
  constructor(...args) {
    super(...args);
    _initializerDefineProperty(this, "tracker", _descriptor2, this);
  }
  get target() {
    return this.tracker.target;
  }
  get renderInPlace() {
    return this.args.renderInPlace === true || !this.target && this.args.fallback === 'inplace';
  }
}, (_descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "tracker", [use], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function () {
    return PortalTrackerResource(() => this.args.target);
  }
})), _class2);
setComponentTemplate(TEMPLATE, Portal);

export { Portal as default };
//# sourceMappingURL=portal.js.map
