import { c as _classPrivateFieldInitSpec, d as _classPrivateFieldGet2, b as _defineProperty } from '../_rollupPluginBabelHelpers-997cc32f.js';
import Service from '@ember/service';
import { assert } from '@ember/debug';
import { next } from '@ember/runloop';
import { TrackedMap } from 'tracked-maps-and-sets';

class TargetTracker {
  constructor(name, element, options) {
    _defineProperty(this, "name", void 0);
    _defineProperty(this, "element", void 0);
    _defineProperty(this, "multiple", void 0);
    _defineProperty(this, "onChange", void 0);
    this.name = name;
    this.element = element;
    this.multiple = options.multiple ?? false;
    this.onChange = options.onChange;
  }
}
var _targets = /*#__PURE__*/new WeakMap();
var _portalCount = /*#__PURE__*/new WeakMap();
class PortalService extends Service {
  constructor(...args) {
    super(...args);
    _classPrivateFieldInitSpec(this, _targets, new TrackedMap());
    _classPrivateFieldInitSpec(this, _portalCount, new TrackedMap());
  }
  getTarget(name) {
    return _classPrivateFieldGet2(_targets, this).get(name);
  }
  getPortalCount(name) {
    return _classPrivateFieldGet2(_portalCount, this).get(name) ?? 0;
  }
  registerTarget(name, element, options) {
    next(this, () => {
      assert(`Portal target with name ${name} already exists`, !_classPrivateFieldGet2(_targets, this).has(name));
      _classPrivateFieldGet2(_targets, this).set(name, new TargetTracker(name, element, options));
    });
  }
  unregisterTarget(name) {
    _classPrivateFieldGet2(_targets, this).delete(name);
    _classPrivateFieldGet2(_portalCount, this).delete(name);
  }
  registerPortal(name) {
    next(this, () => {
      const count = (_classPrivateFieldGet2(_portalCount, this).get(name) ?? 0) + 1;
      _classPrivateFieldGet2(_portalCount, this).set(name, count);
      const target = _classPrivateFieldGet2(_targets, this).get(name);
      if (target && target.onChange) {
        target.onChange(count);
      }
    });
  }
  unregisterPortal(name) {
    let count = _classPrivateFieldGet2(_portalCount, this).get(name);
    if (count === undefined) {
      return;
    }
    count--;
    _classPrivateFieldGet2(_portalCount, this).set(name, count);
    const target = _classPrivateFieldGet2(_targets, this).get(name);
    if (target && target.onChange) {
      target.onChange(count);
    }
  }
}

// DO NOT DELETE: this is how TypeScript knows how to look up your services.

export { PortalService as default };
//# sourceMappingURL=-portal.js.map
